{
This is part of AY Emulator project
AY-3-8910/12 Emulator
Version 2.7 for Windows 95
Author Sergey Vladimirovich Bulba
(c)1999-2003 S.V.Bulba
}

unit AY;

interface
(*
uses
{$IFDEF FPCD}
    sdl, sdl_types,
{$ELSE}
    SDL,
{$ENDIF}
    Globals;
*)
const
//Amplitude tables of sound chips
{ (c)Hacker KAY }
 Amplitudes_AY:array[0..15]of Word=
    (0, 836, 1212, 1773, 2619, 3875, 5397, 8823, 10392, 16706, 23339,
    29292, 36969, 46421, 55195, 65535);
{ (c)V_Soft
 Amplitudes_AY:array[0..15]of Word=
    (0, 513, 828, 1239, 1923, 3238, 4926, 9110, 10344, 17876, 24682,
    30442, 38844, 47270, 56402, 65535);}
{ (c)Lion17
 Amplitudes_YM:array[0..31]of Word=
    (0,  30,  190,  286, 375, 470, 560, 664, 866, 1130, 1515, 1803, 2253,
    2848, 3351, 3862, 4844, 6058, 7290, 8559, 10474, 12878, 15297, 17787,
    21500, 26172, 30866, 35676, 42664, 50986, 58842, 65535);}
{ (c)Hacker KAY }
 Amplitudes_YM:array[0..31]of Word=
    (0, 0, $F8, $1C2, $29E, $33A, $3F2, $4D7, $610, $77F, $90A, $A42,
    $C3B, $EC2, $1137, $13A7, $1750, $1BF9, $20DF, $2596, $2C9D, $3579,
    $3E55, $4768, $54FF, $6624, $773B, $883F, $A1DA, $C0FC, $E094, $FFFF);

type
 PArrayOfByte = ^TArrayOfByte;
 TArrayOfByte = packed array[0..0] of byte;

 TRegisterAY = packed record
 case Integer of
  0:(Index:array[0..15]of byte);
  1:(TonA,TonB,TonC: word;
     Noise:byte;
     Mixer:byte;
     AmplitudeA,AmplitudeB,AmplitudeC:byte;
     Envelope:word;
     EnvType:byte);
 end;

//Available soundchips
  ChTypes = (No_Chip, AY_Chip, YM_Chip);

var
 Optimization_For_Quality:boolean = True;
 BeeperMax:byte;
 RegisterAY:TRegisterAY;
 IntFlag:boolean;
 IntBeeper,IntAY:boolean;
 RegNumNext,DatNext:integer;
 Beeper,BeeperNext:integer;
 BeeperLevel:integer;
 Delay_in_tiks:DWORD;
 FrqAyByFrqZ80:Int64;
 SampleRateByFrqZ80:int64;
 Previous_Tact:integer;
 First_Period:boolean;
 Ampl:smallint;
 Tik:packed record
 case integer of
 0:(Lo:word;
    Hi:word);
 1:(Re:DWORD);
 end;
 Synthesizer,Synthesizer_Beeper:procedure(Buf:pointer);
 Current_Tik:longword;
 Number_Of_Tiks:packed record
 case boolean of
  False:(lo:longword;
         hi:longword);
  True: (re:int64);
 end;
 Envelope_EnA,Envelope_EnB,Envelope_EnC:boolean;
 Flg:smallint;
 Index_AL,Index_AR,Index_BL,Index_BR,Index_CL,Index_CR:byte;
 ChType:ChTypes = YM_Chip;
 PreAmp,PreAmpMax:integer;
 BufP:pointer; //for Z80 emu
 AY_Tiks_In_Interrupt,Sample_Tiks_in_Interrupt:longword;
 ZX_Takt:smallint;
 ZX_Port:word;
 ZX_Port_Data:byte;
 AY_Takt:longint;
 AY_Reg:byte;
 AY_Data:byte;
 Previous_Takt:SmallInt;
 Previous_AY_Takt:longint;
 Number_Of_AY_Takts:longint;
 Current_RegisterAY:byte;

procedure SetEnvelopeRegister(Value:byte);
procedure SetMixerRegister(Value:byte);
procedure SetAmplA(Value:byte);
procedure SetAmplB(Value:byte);
procedure SetAmplC(Value:byte);
procedure SetAYRegister(Num:integer;Value:byte);
procedure SetAYRegisterFast(Num:integer;Value:byte);
procedure SetOptimization(Q:boolean);

procedure Synthesizer_Stereo16(Buf:pointer);
procedure Synthesizer_Stereo16_Beeper(Buf:pointer);
procedure Synthesizer_Stereo16_P(Buf:pointer);
procedure Synthesizer_Stereo16_P_Beeper(Buf:pointer);
procedure Synthesizer_Stereo8(Buf:pointer);
procedure Synthesizer_Stereo8_Beeper(Buf:pointer);
procedure Synthesizer_Stereo8_P(Buf:pointer);
procedure Synthesizer_Stereo8_P_Beeper(Buf:pointer);
procedure Synthesizer_Mono16(Buf:pointer);
procedure Synthesizer_Mono16_P(Buf:pointer);
procedure Synthesizer_Mono16_Beeper(Buf:pointer);
procedure Synthesizer_Mono16_P_Beeper(Buf:pointer);
procedure Synthesizer_Mono8(Buf:pointer);
procedure Synthesizer_Mono8_Beeper(Buf:pointer);
procedure Synthesizer_Mono8_P(Buf:pointer);
procedure Synthesizer_Mono8_P_Beeper(Buf:pointer);
procedure Case_EnvType_0_3__9;
procedure Case_EnvType_4_7__15;
procedure Case_EnvType_8;
procedure Case_EnvType_10;
procedure Case_EnvType_11;
procedure Case_EnvType_12;
procedure Case_EnvType_13;
procedure Case_EnvType_14;
procedure ResetAYChipEmulation;

procedure SynthesizerZX50(Buf:pointer);
{procedure SynthesizerOUT(Buf:pointer);}
{procedure SynthesizerZXAY(Buf:pointer);}
{procedure SynthesizerEPSG(Buf:pointer);}
procedure SynthesizerYM6(Buf:pointer);
{procedure SynthesizerAY;}

procedure Calculate_Level_Tables;

implementation

uses WaveOutAPI, Players;

var
    Ton_Counter_A,
    Ton_Counter_B,
    Ton_Counter_C,
    Noise_Counter:packed record
     case integer of
      0:(Lo:word;
         Hi:word);
      1:(Re:longword);
     end;
    Envelope_Counter:packed record
     case integer of
     0:(Lo:dword;
        Hi:dword);
     1:(Re:int64);
     end;
    Ton_A,Ton_B,Ton_C:byte;
    Noise:packed record
     case boolean of
      True: (Seed:longword);
      False:(Low:word;
             Val:word);
     end;
    Level_AR,Level_AL,
    Level_BR,Level_BL,
    Level_CR,Level_CL:array[0..31]of Integer;
    Left_Chan,Right_Chan:integer;
    Tick_Counter:byte;
    Ton_EnA,Ton_EnB,
    Ton_EnC,Noise_EnA,
    Noise_EnB,Noise_EnC:boolean;
    Case_EnvType:procedure;

type
 TS16 = packed array[0..0] of record
  Left:smallint;
  Right:smallint;
 end;
 PS16 = ^TS16;
 TS8 = packed array[0..0] of record
  Left:byte;
  Right:byte;
 end;
 PS8 = ^TS8;
 TM16 = packed array[0..0] of smallint;
 PM16 = ^TM16;
 TM8 = packed array[0..0] of byte;
 PM8 = ^TM8;

procedure Case_EnvType_0_3__9;
begin
if First_Period then
 begin
 dec(Ampl);
 if Ampl=0 then First_Period:=False
 end
end;

procedure Case_EnvType_4_7__15;
begin
if First_Period then
 begin
 Inc(Ampl);
 if Ampl=32 then
  begin
  First_Period:=False;
  Ampl:=0;
  end
 end
end;

procedure Case_EnvType_8;
begin
Ampl:=(Ampl-1)and 31;
end;

procedure Case_EnvType_10;
begin
if First_Period then
 begin
 dec(Ampl);
 if Ampl=-1 then
  begin
  First_Period:=False;
  Ampl:=0
  end
 end
else
 begin
 inc(Ampl);
 if Ampl=32 then
  begin
  First_Period:=True;
  Ampl:=31
  end
 end
end;

procedure Case_EnvType_11;
begin
if First_Period then
 begin
 dec(Ampl);
 if Ampl=-1 then
  begin
  First_Period:=False;
  Ampl:=31
  end
 end
end;

procedure Case_EnvType_12;
begin
Ampl:=(Ampl+1)and 31;
end;

Procedure Case_EnvType_13;
begin
if First_Period then
 begin
 inc(Ampl);
 if Ampl=32 then
  begin
  First_Period:=False;
  Ampl:=31
  end
 end
end;

Procedure Case_EnvType_14;
begin
if not First_Period then
 begin
 dec(Ampl);
 if Ampl=-1 then
  begin
  First_Period:=True;
  Ampl:=0
  end
 end
else
 begin
 inc(Ampl);
 if Ampl=32 then
  begin
  First_Period:=False;
  Ampl:=31
  end
 end
end;

procedure Synthesizer_Logic_Q;
begin
inc(Ton_Counter_A.Hi);
if Ton_Counter_A.Hi>=RegisterAY.TonA then
 begin
 Ton_Counter_A.Hi:=0;
 Ton_A:=Ton_A xor 1
 end;
inc(Ton_Counter_B.Hi);
if Ton_Counter_B.Hi>=RegisterAY.TonB then
 begin
 Ton_Counter_B.Hi:=0;
 Ton_B:=Ton_B xor 1
 end;
inc(Ton_Counter_C.Hi);
if Ton_Counter_C.Hi>=RegisterAY.TonC then
 begin
 Ton_Counter_C.Hi:=0;
 Ton_C:=Ton_C xor 1
 end;
inc(Noise_Counter.Hi);
if (Noise_Counter.Hi and 1 = 0) and
   (Noise_Counter.Hi>=RegisterAY.Noise shl 1) then
 begin
 Noise_Counter.Hi:=0;
 Noise.Val := random(2); {see readme for details about noise algorithm}
 end;
if Envelope_Counter.Hi = 0 then Case_EnvType;
inc(Envelope_Counter.Hi);
If Envelope_Counter.Hi>=RegisterAY.Envelope then
 Envelope_Counter.Hi:=0
end;

procedure Synthesizer_Logic_P;
var
 k:word;
 k2:longword;
begin
inc(Ton_Counter_A.Re,Delay_In_Tiks);
if RegisterAY.TonA=0 then k:=1 else k:=RegisterAY.TonA;
if k<=Ton_Counter_A.Hi then
 begin
 Ton_A:=Ton_A xor ((Ton_Counter_A.Hi div k) and 1);
 Ton_Counter_A.Hi:=Ton_Counter_A.Hi mod k
 end;

inc(Ton_Counter_B.Re,Delay_In_Tiks);
if RegisterAY.TonB=0 then k:=1 else k:=RegisterAY.TonB;
if k<=Ton_Counter_B.Hi then
 begin
 Ton_B:=Ton_B xor ((Ton_Counter_B.Hi div k) and 1);
 Ton_Counter_B.Hi:=Ton_Counter_B.Hi mod k
 end;

inc(Ton_Counter_C.Re,Delay_In_Tiks);
if RegisterAY.TonC=0 then k:=1 else k:=RegisterAY.TonC;
if k<=Ton_Counter_C.Hi then
 begin
 Ton_C:=Ton_C xor ((Ton_Counter_C.Hi div k) and 1);
 Ton_Counter_C.Hi:=Ton_Counter_C.Hi mod k
 end;

inc(Noise_Counter.Re,Delay_In_Tiks);
if RegisterAY.Noise=0 then k:=2 else k:=RegisterAY.Noise shl 1;
if Noise_Counter.Hi>=k then
 begin
 Noise_Counter.Hi:=Noise_Counter.Hi mod k;
 Noise.Val := random(2); {see readme for details about noise algorithm}
 end;

if RegisterAY.Envelope=0 then k2:=1
else k2:=RegisterAY.Envelope;
if Envelope_Counter.Hi=0 then inc(Envelope_Counter.Hi,k2);
while (Envelope_Counter.Hi>=k2) do
 begin
 dec(Envelope_Counter.Hi,k2);
 Case_EnvType
 end;
inc(Envelope_Counter.Re,int64(Delay_In_Tiks) shl 16);
end;

procedure SetMixerRegister(Value:byte);
begin
RegisterAY.Mixer := Value;
Ton_EnA := (Value and 1) = 0;
Noise_EnA := (Value and 8) = 0;
Ton_EnB := (Value and 2) = 0;
Noise_EnB := (Value and 16) = 0;
Ton_EnC := (Value and 4) = 0;
Noise_EnC := (Value and 32) = 0
end;

procedure SetEnvelopeRegister(Value:byte);
begin
Envelope_Counter.Hi := 0;
First_Period := True;
if (Value and 4) = 0 then
 ampl := 32
else
 ampl := -1;
RegisterAY.EnvType := Value;
Case Value of
0..3,9: Case_EnvType := Case_EnvType_0_3__9;
4..7,15:Case_EnvType := Case_EnvType_4_7__15;
8:      Case_EnvType := Case_EnvType_8;
10:     Case_EnvType := Case_EnvType_10;
11:     Case_EnvType := Case_EnvType_11;
12:     Case_EnvType := Case_EnvType_12;
13:     Case_EnvType := Case_EnvType_13;
14:     Case_EnvType := Case_EnvType_14;
end;
end;

procedure SetAmplA(Value:byte);
begin
RegisterAY.AmplitudeA := Value;
Envelope_EnA := (Value and 16) = 0;
end;

procedure SetAmplB(Value:byte);
begin
RegisterAY.AmplitudeB := Value;
Envelope_EnB := (Value and 16) = 0;
end;

procedure SetAmplC(Value:byte);
begin
RegisterAY.AmplitudeC := Value;
Envelope_EnC := (Value and 16) = 0;
end;

procedure SetAYRegister(Num:integer;Value:byte);
begin
case Num of
13:
 SetEnvelopeRegister(Value and 15);
1,3,5:
 RegisterAY.Index[Num] := Value and 15;
6:
 RegisterAY.Noise := Value and 31;
7: SetMixerRegister(Value and 63);
8: SetAmplA(Value and 31);
9: SetAmplB(Value and 31);
10:SetAmplC(Value and 31);
0,2,4,11,12:
 RegisterAY.Index[Num] := Value
end
end;

procedure SetAYRegisterFast(Num:integer;Value:byte);
begin
case Num of
13:
 SetEnvelopeRegister(Value);
1,3,5:
 RegisterAY.Index[Num] := Value;
6:
 RegisterAY.Noise := Value;
7: SetMixerRegister(Value);
8: SetAmplA(Value);
9: SetAmplB(Value);
10:SetAmplC(Value);
0,2,4,11,12:
 RegisterAY.Index[Num] := Value
end
end;

procedure Synthesizer_Mixer_Q;
var
 LevL,LevR,k:integer;
begin
LevL := 0;
LevR := LevL;
if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
if k <> 0 then
 begin
  if Envelope_EnA then
   begin
    LevL := Level_AL[RegisterAY.AmplitudeA * 2 + 1];
    LevR := Level_AR[RegisterAY.AmplitudeA * 2 + 1];
   end
  else
   begin
    LevL := Level_AL[Ampl];
    LevR := Level_AR[Ampl];
   end
 end;

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  begin
   inc(LevL,Level_BL[RegisterAY.AmplitudeB * 2 + 1]);
   inc(LevR,Level_BR[RegisterAY.AmplitudeB * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_BL[Ampl]);
   inc(LevR,Level_BR[Ampl]);
  end;

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  begin
   inc(LevL,Level_CL[RegisterAY.AmplitudeC * 2 + 1]);
   inc(LevR,Level_CR[RegisterAY.AmplitudeC * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_CL[Ampl]);
   inc(LevR,Level_CR[Ampl]);
  end;
inc(Left_Chan,LevL);
inc(Right_Chan,LevR)
end;

procedure Synthesizer_Mixer_Q_Beeper;
var
 LevL,LevR,k:integer;
begin
LevL := Beeper;
LevR := LevL;
if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
if k <> 0 then
 begin
  if Envelope_EnA then
   begin
    inc(LevL,Level_AL[RegisterAY.AmplitudeA * 2 + 1]);
    inc(LevR,Level_AR[RegisterAY.AmplitudeA * 2 + 1]);
   end
  else
   begin
    inc(LevL,Level_AL[Ampl]);
    inc(LevR,Level_AR[Ampl]);
   end
 end;

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  begin
   inc(LevL,Level_BL[RegisterAY.AmplitudeB * 2 + 1]);
   inc(LevR,Level_BR[RegisterAY.AmplitudeB * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_BL[Ampl]);
   inc(LevR,Level_BR[Ampl]);
  end;

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  begin
   inc(LevL,Level_CL[RegisterAY.AmplitudeC * 2 + 1]);
   inc(LevR,Level_CR[RegisterAY.AmplitudeC * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_CL[Ampl]);
   inc(LevR,Level_CR[Ampl]);
  end;
inc(Left_Chan,LevL);
inc(Right_Chan,LevR)
end;

procedure Synthesizer_Stereo16;
var
 Tmp:integer;
begin
repeat
Synthesizer_Logic_Q;
Synthesizer_Mixer_Q;
Inc(Current_Tik);
Inc(Tick_Counter);
if Tick_Counter >= Tik.Hi then
 begin
  Inc(Tik.Re,Delay_In_Tiks);
  Dec(Tik.Hi,Tick_Counter);
  {if NOfTicks = VisPoint then
   begin
    VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
    VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
    VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
    VisPoints[MkVisPos].TonA := RegisterAY.TonA;
    VisPoints[MkVisPos].TonB := RegisterAY.TonB;
    VisPoints[MkVisPos].TonC := RegisterAY.TonC;
    if MkVisPos < VisPosMax - 1 then
     Inc(MkVisPos)
    else
     MkVisPos := 0;
    Inc(VisPoint,VisStep)
   end;}
  Inc(NOfTicks);
  PS16(Buf)^[BuffLen].Left := Left_Chan div Tick_Counter;
  PS16(Buf)^[BuffLen].Right := Right_Chan div Tick_Counter;
  Inc(BuffLen);
  Tmp := 0;
  Left_Chan:= Tmp;
  Right_Chan := Tmp;
  Tick_Counter := Tmp;
  if BuffLen = BufferLength then
   begin
    if Current_Tik < Number_Of_Tiks.Hi then
     IntFlag := True;
    exit
   end
 end
until Current_Tik >= Number_Of_Tiks.Hi;
Tmp := 0;
Number_Of_Tiks.hi := Tmp;
Current_Tik := Tmp
end;

procedure Synthesizer_Stereo16_Beeper;
var
 Tmp:integer;
begin
repeat
Synthesizer_Logic_Q;
Synthesizer_Mixer_Q_Beeper;
Inc(Current_Tik);
Inc(Tick_Counter);
if Tick_Counter >= Tik.Hi then
 begin
  Inc(Tik.Re,Delay_In_Tiks);
  Dec(Tik.Hi,Tick_Counter);
  {if NOfTicks = VisPoint then
   begin
    VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
    VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
    VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
    VisPoints[MkVisPos].TonA := RegisterAY.TonA;
    VisPoints[MkVisPos].TonB := RegisterAY.TonB;
    VisPoints[MkVisPos].TonC := RegisterAY.TonC;
    if MkVisPos < VisPosMax - 1 then
     Inc(MkVisPos)
    else
     MkVisPos := 0;
    Inc(VisPoint,VisStep)
   end;}
  Inc(NOfTicks);
  PS16(Buf)^[BuffLen].Left := Left_Chan div Tick_Counter;
  PS16(Buf)^[BuffLen].Right := Right_Chan div Tick_Counter;
  Inc(BuffLen);
  Tmp := 0;
  Left_Chan:= Tmp;
  Right_Chan := Tmp;
  Tick_Counter := Tmp;
  if BuffLen = BufferLength then
   begin
    if Current_Tik < Number_Of_Tiks.Hi then
     IntFlag := True;
    exit
   end
 end
until Current_Tik >= Number_Of_Tiks.Hi;
Tmp := 0;
Number_Of_Tiks.hi := Tmp;
Current_Tik := Tmp
end;

procedure Synthesizer_Stereo8;
var
 Tmp:integer;
begin
repeat
Synthesizer_Logic_Q;
Synthesizer_Mixer_Q;
Inc(Current_Tik);
Inc(Tick_Counter);
if Tick_Counter >= Tik.Hi then
 begin
  Inc(Tik.Re,Delay_In_Tiks);
  Dec(Tik.Hi,Tick_Counter);
  {if NOfTicks = VisPoint then
   begin
    VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
    VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
    VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
    VisPoints[MkVisPos].TonA := RegisterAY.TonA;
    VisPoints[MkVisPos].TonB := RegisterAY.TonB;
    VisPoints[MkVisPos].TonC := RegisterAY.TonC;
    if MkVisPos < VisPosMax - 1 then
     Inc(MkVisPos)
    else
     MkVisPos := 0;
    Inc(VisPoint,VisStep)
   end;}
  Inc(NOfTicks);
  PS8(Buf)^[BuffLen].Left := 128 + Left_Chan div Tick_Counter;
  PS8(Buf)^[BuffLen].Right := 128 + Right_Chan div Tick_Counter;
  Inc(BuffLen);
  Tmp := 0;
  Left_Chan := Tmp;
  Right_Chan := Tmp;
  Tick_Counter := Tmp;
  if BuffLen = BufferLength then
   begin
    if Current_Tik < Number_Of_Tiks.Hi then
     IntFlag := True;
    exit
   end
 end
until Current_Tik >= Number_Of_Tiks.Hi;
Tmp := 0;
Number_Of_Tiks.hi := Tmp;
Current_Tik := Tmp
end;

procedure Synthesizer_Stereo8_Beeper;
var
 Tmp:integer;
begin
repeat
Synthesizer_Logic_Q;
Synthesizer_Mixer_Q_Beeper;
Inc(Current_Tik);
Inc(Tick_Counter);
if Tick_Counter >= Tik.Hi then
 begin
  Inc(Tik.Re,Delay_In_Tiks);
  Dec(Tik.Hi,Tick_Counter);
  {if NOfTicks = VisPoint then
   begin
    VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
    VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
    VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
    VisPoints[MkVisPos].TonA := RegisterAY.TonA;
    VisPoints[MkVisPos].TonB := RegisterAY.TonB;
    VisPoints[MkVisPos].TonC := RegisterAY.TonC;
    if MkVisPos < VisPosMax - 1 then
     Inc(MkVisPos)
    else
     MkVisPos := 0;
    Inc(VisPoint,VisStep)
   end;}
  Inc(NOfTicks);
  PS8(Buf)^[BuffLen].Left := 128 + Left_Chan div Tick_Counter;
  PS8(Buf)^[BuffLen].Right := 128 + Right_Chan div Tick_Counter;
  Inc(BuffLen);
  Tmp := 0;
  Left_Chan := Tmp;
  Right_Chan := Tmp;
  Tick_Counter := Tmp;
  if BuffLen = BufferLength then
   begin
    if Current_Tik < Number_Of_Tiks.Hi then
     IntFlag := True;
    exit
   end
 end
until Current_Tik >= Number_Of_Tiks.Hi;
Tmp := 0;
Number_Of_Tiks.hi := Tmp;
Current_Tik := Tmp
end;

procedure Synthesizer_Mixer_Q_Mono;
var
 Lev,k:integer;
begin
Lev := 0;
if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnA then
  Lev := Level_AL[RegisterAY.AmplitudeA * 2 + 1]
 else
  Lev := Level_AL[Ampl];

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  inc(Lev,Level_BL[RegisterAY.AmplitudeB * 2 + 1])
 else
  inc(Lev,Level_BL[Ampl]);

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  inc(Lev,Level_CL[RegisterAY.AmplitudeC * 2 + 1])
 else
  inc(Lev,Level_CL[Ampl]);
inc(Left_Chan,Lev)
end;

procedure Synthesizer_Mixer_Q_Mono_Beeper;
var
 Lev,k:integer;
begin
Lev := Beeper;
if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnA then
  inc(Lev,Level_AL[RegisterAY.AmplitudeA * 2 + 1])
 else
  inc(Lev,Level_AL[Ampl]);

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  inc(Lev,Level_BL[RegisterAY.AmplitudeB * 2 + 1])
 else
  inc(Lev,Level_BL[Ampl]);

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  inc(Lev,Level_CL[RegisterAY.AmplitudeC * 2 + 1])
 else
  inc(Lev,Level_CL[Ampl]);
inc(Left_Chan,Lev)
end;

procedure Synthesizer_Mono16;
var
 Tmp:integer;
begin
repeat
Synthesizer_Logic_Q;
Synthesizer_Mixer_Q_Mono;
Inc(Current_Tik);
Inc(Tick_Counter);
if Tick_Counter >= Tik.Hi then
 begin
  Inc(Tik.Re,Delay_In_Tiks);
  Dec(Tik.Hi,Tick_Counter);
  {if NOfTicks = VisPoint then
   begin
    VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
    VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
    VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
    VisPoints[MkVisPos].TonA := RegisterAY.TonA;
    VisPoints[MkVisPos].TonB := RegisterAY.TonB;
    VisPoints[MkVisPos].TonC := RegisterAY.TonC;
    if MkVisPos < VisPosMax - 1 then
     Inc(MkVisPos)
    else
     MkVisPos := 0;
    Inc(VisPoint,VisStep)
   end;}
  Inc(NOfTicks);
  PM16(Buf)^[BuffLen] := Left_Chan div Tick_Counter;
  Inc(BuffLen);
  Tmp := 0;
  Left_Chan := Tmp;
  Tick_Counter := Tmp;
  if BuffLen = BufferLength then
   begin
    if Current_Tik < Number_Of_Tiks.Hi then
     IntFlag := True;
    exit
   end
 end
until Current_Tik >= Number_Of_Tiks.Hi;
Tmp := 0;
Number_Of_Tiks.hi := Tmp;
Current_Tik := Tmp
end;

procedure Synthesizer_Mono16_Beeper;
var
 Tmp:integer;
begin
repeat
Synthesizer_Logic_Q;
Synthesizer_Mixer_Q_Mono_Beeper;
Inc(Current_Tik);
Inc(Tick_Counter);
if Tick_Counter >= Tik.Hi then
 begin
  Inc(Tik.Re,Delay_In_Tiks);
  Dec(Tik.Hi,Tick_Counter);
  {if NOfTicks = VisPoint then
   begin
    VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
    VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
    VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
    VisPoints[MkVisPos].TonA := RegisterAY.TonA;
    VisPoints[MkVisPos].TonB := RegisterAY.TonB;
    VisPoints[MkVisPos].TonC := RegisterAY.TonC;
    if MkVisPos < VisPosMax - 1 then
     Inc(MkVisPos)
    else
     MkVisPos := 0;
    Inc(VisPoint,VisStep)
   end;}
  Inc(NOfTicks);
  PM16(Buf)^[BuffLen] := Left_Chan div Tick_Counter;
  Inc(BuffLen);
  Tmp := 0;
  Left_Chan := Tmp;
  Tick_Counter := Tmp;
  if BuffLen = BufferLength then
   begin
    if Current_Tik < Number_Of_Tiks.Hi then
     IntFlag := True;
    exit
   end
 end
until Current_Tik >= Number_Of_Tiks.Hi;
Tmp := 0;
Number_Of_Tiks.hi := Tmp;
Current_Tik := Tmp
end;

procedure Synthesizer_Mono8;
var
 Tmp:integer;
begin
repeat
Synthesizer_Logic_Q;
Synthesizer_Mixer_Q_Mono;
Inc(Current_Tik);
Inc(Tick_Counter);
if Tick_Counter >= Tik.Hi then
 begin
  Inc(Tik.Re,Delay_In_Tiks);
  Dec(Tik.Hi,Tick_Counter);
  {if NOfTicks = VisPoint then
   begin
    VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
    VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
    VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
    VisPoints[MkVisPos].TonA := RegisterAY.TonA;
    VisPoints[MkVisPos].TonB := RegisterAY.TonB;
    VisPoints[MkVisPos].TonC := RegisterAY.TonC;
    if MkVisPos < VisPosMax - 1 then
     Inc(MkVisPos)
    else
     MkVisPos := 0;
    Inc(VisPoint,VisStep)
   end;}
  Inc(NOfTicks);
  PM8(Buf)^[BuffLen] := 128 + Left_Chan div Tick_Counter;
  Inc(BuffLen);
  Tmp := 0;
  Left_Chan := Tmp;
  Tick_Counter := Tmp;
  if BuffLen = BufferLength then
   begin
    if Current_Tik < Number_Of_Tiks.Hi then
     IntFlag := True;
    exit
   end
 end
until Current_Tik >= Number_Of_Tiks.Hi;
Tmp := 0;
Number_Of_Tiks.hi := Tmp;
Current_Tik := Tmp
end;

procedure Synthesizer_Mono8_Beeper;
var
 Tmp:integer;
begin
repeat
Synthesizer_Logic_Q;
Synthesizer_Mixer_Q_Mono_Beeper;
Inc(Current_Tik);
Inc(Tick_Counter);
if Tick_Counter >= Tik.Hi then
 begin
  Inc(Tik.Re,Delay_In_Tiks);
  Dec(Tik.Hi,Tick_Counter);
  {if NOfTicks = VisPoint then
   begin
    VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
    VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
    VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
    VisPoints[MkVisPos].TonA := RegisterAY.TonA;
    VisPoints[MkVisPos].TonB := RegisterAY.TonB;
    VisPoints[MkVisPos].TonC := RegisterAY.TonC;
    if MkVisPos < VisPosMax - 1 then
     Inc(MkVisPos)
    else
     MkVisPos := 0;
    Inc(VisPoint,VisStep)
   end;}
  Inc(NOfTicks);
  PM8(Buf)^[BuffLen] := 128 + Left_Chan div Tick_Counter;
  Inc(BuffLen);
  Tmp := 0;
  Left_Chan := Tmp;
  Tick_Counter := Tmp;
  if BuffLen = BufferLength then
   begin
    if Current_Tik < Number_Of_Tiks.Hi then
     IntFlag := True;
    exit
   end
 end
until Current_Tik >= Number_Of_Tiks.Hi;
Tmp := 0;
Number_Of_Tiks.hi := Tmp;
Current_Tik := Tmp
end;

procedure Synthesizer_Stereo16_P;
var
 LevL,LevR,k:integer;
begin
repeat
Synthesizer_Logic_P;
LevL := 0;
LevR := LevL;

if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
 if k <> 0 then
  if Envelope_EnA then
   begin
    LevL := Level_AL[RegisterAY.AmplitudeA * 2 + 1];
    LevR := Level_AR[RegisterAY.AmplitudeA * 2 + 1];
   end
  else
   begin
    LevL := Level_AL[Ampl];
    LevR := Level_AR[Ampl];
   end;

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  begin
   inc(LevL,Level_BL[RegisterAY.AmplitudeB * 2 + 1]);
   inc(LevR,Level_BR[RegisterAY.AmplitudeB * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_BL[Ampl]);
   inc(LevR,Level_BR[Ampl]);
  end;

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  begin
   inc(LevL,Level_CL[RegisterAY.AmplitudeC * 2 + 1]);
   inc(LevR,Level_CR[RegisterAY.AmplitudeC * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_CL[Ampl]);
   inc(LevR,Level_CR[Ampl]);
  end;

{if NOfTicks = VisPoint then
 begin
  VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
  VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
  VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
  VisPoints[MkVisPos].TonA := RegisterAY.TonA;
  VisPoints[MkVisPos].TonB := RegisterAY.TonB;
  VisPoints[MkVisPos].TonC := RegisterAY.TonC;
  if MkVisPos < VisPosMax - 1 then
   Inc(MkVisPos)
  else
   MkVisPos := 0;
  Inc(VisPoint,VisStep)
 end;}
Inc(NOfTicks);
PS16(Buf)^[BuffLen].Left := LevL;
PS16(Buf)^[BuffLen].Right := LevR;
Inc(BuffLen);
inc(Current_Tik);
if BuffLen = BufferLength then
 begin
  if Current_Tik < Number_Of_Tiks.Hi then
   IntFlag := True;
  exit
 end;
until Current_Tik >= Number_Of_Tiks.Hi;
k := 0;
Number_Of_Tiks.hi := k;
Current_Tik := k
end;

procedure Synthesizer_Stereo16_P_Beeper;
var
 LevL,LevR,k:integer;
begin
repeat
Synthesizer_Logic_P;
LevL := Beeper;
LevR := LevL;

if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
 if k <> 0 then
  if Envelope_EnA then
   begin
    inc(LevL,Level_AL[RegisterAY.AmplitudeA * 2 + 1]);
    inc(LevR,Level_AR[RegisterAY.AmplitudeA * 2 + 1]);
   end
  else
   begin
    inc(LevL,Level_AL[Ampl]);
    inc(LevR,Level_AR[Ampl]);
   end;

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  begin
   inc(LevL,Level_BL[RegisterAY.AmplitudeB * 2 + 1]);
   inc(LevR,Level_BR[RegisterAY.AmplitudeB * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_BL[Ampl]);
   inc(LevR,Level_BR[Ampl]);
  end;

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  begin
   inc(LevL,Level_CL[RegisterAY.AmplitudeC * 2 + 1]);
   inc(LevR,Level_CR[RegisterAY.AmplitudeC * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_CL[Ampl]);
   inc(LevR,Level_CR[Ampl]);
  end;

{if NOfTicks = VisPoint then
 begin
  VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
  VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
  VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
  VisPoints[MkVisPos].TonA := RegisterAY.TonA;
  VisPoints[MkVisPos].TonB := RegisterAY.TonB;
  VisPoints[MkVisPos].TonC := RegisterAY.TonC;
  if MkVisPos < VisPosMax - 1 then
   Inc(MkVisPos)
  else
   MkVisPos := 0;
  Inc(VisPoint,VisStep)
 end;}
Inc(NOfTicks);
PS16(Buf)^[BuffLen].Left := LevL;
PS16(Buf)^[BuffLen].Right := LevR;
Inc(BuffLen);
Inc(Current_Tik);
if BuffLen = BufferLength then
 begin
  if Current_Tik < Number_Of_Tiks.Hi then
   IntFlag := True;
  exit
 end;
until Current_Tik >= Number_Of_Tiks.Hi;
k := 0;
Number_Of_Tiks.hi := k;
Current_Tik := k
end;

procedure Synthesizer_Stereo8_P;
var
 LevL,LevR,k:integer;
begin
repeat
Synthesizer_Logic_P;
LevL := 128;
LevR := LevL;

if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnA then
  begin
   inc(LevL,Level_AL[RegisterAY.AmplitudeA * 2 + 1]);
   inc(LevR,Level_AR[RegisterAY.AmplitudeA * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_AL[Ampl]);
   inc(LevR,Level_AR[Ampl]);
  end;

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  begin
   inc(LevL,Level_BL[RegisterAY.AmplitudeB * 2 + 1]);
   inc(LevR,Level_BR[RegisterAY.AmplitudeB * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_BL[Ampl]);
   inc(LevR,Level_BR[Ampl]);
  end;

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  begin
   inc(LevL,Level_CL[RegisterAY.AmplitudeC * 2 + 1]);
   inc(LevR,Level_CR[RegisterAY.AmplitudeC * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_CL[Ampl]);
   inc(LevR,Level_CR[Ampl]);
  end;

{if NOfTicks = VisPoint then
 begin
  VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
  VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
  VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
  VisPoints[MkVisPos].TonA := RegisterAY.TonA;
  VisPoints[MkVisPos].TonB := RegisterAY.TonB;
  VisPoints[MkVisPos].TonC := RegisterAY.TonC;
  if MkVisPos < VisPosMax - 1 then
   Inc(MkVisPos)
  else
   MkVisPos := 0;
  Inc(VisPoint,VisStep)
 end;}
Inc(NOfTicks);
PS8(Buf)^[BuffLen].Left := LevL;
PS8(Buf)^[BuffLen].Right := LevR;
Inc(BuffLen);
Inc(Current_Tik);
if BuffLen = BufferLength then
 begin
  if Current_Tik < Number_Of_Tiks.Hi then
   IntFlag := True;
  exit
 end
until Current_Tik >= Number_Of_Tiks.Hi;
k := 0;
Number_Of_Tiks.hi := k;
Current_Tik := k
end;

procedure Synthesizer_Stereo8_P_Beeper;
var
 LevL,LevR,k:integer;
begin
repeat
Synthesizer_Logic_P;
LevL := 128 + Beeper;
LevR := LevL;

if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnA then
  begin
   inc(LevL,Level_AL[RegisterAY.AmplitudeA * 2 + 1]);
   inc(LevR,Level_AR[RegisterAY.AmplitudeA * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_AL[Ampl]);
   inc(LevR,Level_AR[Ampl]);
  end;

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  begin
   inc(LevL,Level_BL[RegisterAY.AmplitudeB * 2 + 1]);
   inc(LevR,Level_BR[RegisterAY.AmplitudeB * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_BL[Ampl]);
   inc(LevR,Level_BR[Ampl]);
  end;

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  begin
   inc(LevL,Level_CL[RegisterAY.AmplitudeC * 2 + 1]);
   inc(LevR,Level_CR[RegisterAY.AmplitudeC * 2 + 1]);
  end
 else
  begin
   inc(LevL,Level_CL[Ampl]);
   inc(LevR,Level_CR[Ampl]);
  end;

{if NOfTicks = VisPoint then
 begin
  VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
  VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
  VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
  VisPoints[MkVisPos].TonA := RegisterAY.TonA;
  VisPoints[MkVisPos].TonB := RegisterAY.TonB;
  VisPoints[MkVisPos].TonC := RegisterAY.TonC;
  if MkVisPos < VisPosMax - 1 then
   Inc(MkVisPos)
  else
   MkVisPos := 0;
  Inc(VisPoint,VisStep)
 end;}
Inc(NOfTicks);
PS8(Buf)^[BuffLen].Left := LevL;
PS8(Buf)^[BuffLen].Right := LevR;
Inc(BuffLen);
Inc(Current_Tik);
if BuffLen = BufferLength then
 begin
  if Current_Tik < Number_Of_Tiks.Hi then
   IntFlag := True;
  exit
 end
until Current_Tik >= Number_Of_Tiks.Hi;
k := 0;
Number_Of_Tiks.hi := k;
Current_Tik := k
end;

procedure Synthesizer_Mono16_P;
var
 Lev,k:integer;
begin
repeat
Synthesizer_Logic_P;
Lev := 0;

if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnA then
  Lev := Level_AL[RegisterAY.AmplitudeA * 2 + 1]
 else
  Lev := Level_AL[Ampl];

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  inc(Lev,Level_BL[RegisterAY.AmplitudeB * 2 + 1])
 else
  inc(Lev,Level_BL[Ampl]);

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  inc(Lev,Level_CL[RegisterAY.AmplitudeC * 2 + 1])
 else
  inc(Lev,Level_CL[Ampl]);

{if NOfTicks = VisPoint then
 begin
  VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
  VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
  VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
  VisPoints[MkVisPos].TonA := RegisterAY.TonA;
  VisPoints[MkVisPos].TonB := RegisterAY.TonB;
  VisPoints[MkVisPos].TonC := RegisterAY.TonC;
  if MkVisPos < VisPosMax - 1 then
   Inc(MkVisPos)
  else
   MkVisPos := 0;
  Inc(VisPoint,VisStep)
 end;}
Inc(NOfTicks);
PM16(Buf)^[BuffLen] := Lev;
Inc(BuffLen);
Inc(Current_Tik);
if BuffLen = BufferLength then
 begin
  if Current_Tik < Number_Of_Tiks.Hi then
   IntFlag := True;
  exit
 end
until Current_Tik >= Number_Of_Tiks.Hi;
k := 0;
Number_Of_Tiks.hi := k;
Current_Tik := k
end;

procedure Synthesizer_Mono16_P_Beeper;
var
 Lev,k:integer;
begin
repeat
Synthesizer_Logic_P;
Lev := Beeper;

if Ton_EnA then k := Ton_A else k := 1;
if Noise_EnA then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnA then
  inc(Lev,Level_AL[RegisterAY.AmplitudeA * 2 + 1])
 else
  inc(Lev,Level_AL[Ampl]);

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  inc(Lev,Level_BL[RegisterAY.AmplitudeB * 2 + 1])
 else
  inc(Lev,Level_BL[Ampl]);

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  inc(Lev,Level_CL[RegisterAY.AmplitudeC * 2 + 1])
 else
  inc(Lev,Level_CL[Ampl]);

{if NOfTicks = VisPoint then
 begin
  VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
  VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
  VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
  VisPoints[MkVisPos].TonA := RegisterAY.TonA;
  VisPoints[MkVisPos].TonB := RegisterAY.TonB;
  VisPoints[MkVisPos].TonC := RegisterAY.TonC;
  if MkVisPos < VisPosMax - 1 then
   Inc(MkVisPos)
  else
   MkVisPos := 0;
  Inc(VisPoint,VisStep)
 end;}
Inc(NOfTicks);
PM16(Buf)^[BuffLen] := Lev;
Inc(BuffLen);
Inc(Current_Tik);
if BuffLen = BufferLength then
 begin
  if Current_Tik < Number_Of_Tiks.Hi then
   IntFlag := True;
  exit
 end
until Current_Tik >= Number_Of_Tiks.Hi;
k := 0;
Number_Of_Tiks.hi := k;
Current_Tik := k
end;

procedure Synthesizer_Mono8_P;
var
 Lev,k:integer;
begin
repeat
Synthesizer_Logic_P;
Lev := 128;

if Ton_EnA then k:=Ton_A else k:=1;
if Noise_EnA then k:=k and Noise.Val;
if k<>0 then
 if Envelope_EnA then
  inc(Lev,Level_AL[RegisterAY.AmplitudeA * 2 + 1])
 else
  inc(Lev,Level_AL[Ampl]);

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  inc(Lev,Level_BL[RegisterAY.AmplitudeB * 2 + 1])
 else
  inc(Lev,Level_BL[Ampl]);

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  inc(Lev,Level_CL[RegisterAY.AmplitudeC*2+1])
 else
  inc(Lev,Level_CL[Ampl]);

{if NOfTicks = VisPoint then
 begin
  VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
  VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
  VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
  VisPoints[MkVisPos].TonA := RegisterAY.TonA;
  VisPoints[MkVisPos].TonB := RegisterAY.TonB;
  VisPoints[MkVisPos].TonC := RegisterAY.TonC;
  if MkVisPos < VisPosMax - 1 then
   Inc(MkVisPos)
  else
   MkVisPos := 0;
  Inc(VisPoint,VisStep)
 end;}
Inc(NOfTicks);
PM8(Buf)^[BuffLen] := Lev;
Inc(BuffLen);
Inc(Current_Tik);
if BuffLen = BufferLength then
 begin
  if Current_Tik < Number_Of_Tiks.Hi then
   IntFlag := True;
  exit
 end
until Current_Tik >= Number_Of_Tiks.Hi;
k := 0;
Number_Of_Tiks.hi := k;
Current_Tik := k
end;

procedure Synthesizer_Mono8_P_Beeper;
var
 Lev,k:integer;
begin
repeat
Synthesizer_Logic_P;
Lev := 128 + Beeper;

if Ton_EnA then k:=Ton_A else k:=1;
if Noise_EnA then k:=k and Noise.Val;
if k<>0 then
 if Envelope_EnA then
  inc(Lev,Level_AL[RegisterAY.AmplitudeA * 2 + 1])
 else
  inc(Lev,Level_AL[Ampl]);

if Ton_EnB then k := Ton_B else k := 1;
if Noise_EnB then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnB then
  inc(Lev,Level_BL[RegisterAY.AmplitudeB * 2 + 1])
 else
  inc(Lev,Level_BL[Ampl]);

if Ton_EnC then k := Ton_C else k := 1;
if Noise_EnC then k := k and Noise.Val;
if k <> 0 then
 if Envelope_EnC then
  inc(Lev,Level_CL[RegisterAY.AmplitudeC*2+1])
 else
  inc(Lev,Level_CL[Ampl]);

{if NOfTicks = VisPoint then
 begin
  VisPoints[MkVisPos].AmpA := RegisterAY.AmplitudeA and 15;
  VisPoints[MkVisPos].AmpB := RegisterAY.AmplitudeB and 15;
  VisPoints[MkVisPos].AmpC := RegisterAY.AmplitudeC and 15;
  VisPoints[MkVisPos].TonA := RegisterAY.TonA;
  VisPoints[MkVisPos].TonB := RegisterAY.TonB;
  VisPoints[MkVisPos].TonC := RegisterAY.TonC;
  if MkVisPos < VisPosMax - 1 then
   Inc(MkVisPos)
  else
   MkVisPos := 0;
  Inc(VisPoint,VisStep)
 end;}
Inc(NOfTicks);
PM8(Buf)^[BuffLen] := Lev;
Inc(BuffLen);
Inc(Current_Tik);
if BuffLen = BufferLength then
 begin
  if Current_Tik < Number_Of_Tiks.Hi then
   IntFlag := True;
  exit
 end
until Current_Tik >= Number_Of_Tiks.Hi;
k := 0;
Number_Of_Tiks.hi := k;
Current_Tik := k
end;

procedure ResetAYChipEmulation;
begin
Flg := 0;
IntFlag := False;
Number_Of_Tiks.Re := 0;
Current_Tik := 0;
Envelope_Counter.Re := 0;
Ton_Counter_A.Re := 0;
Ton_Counter_B.Re := 0;
Ton_Counter_C.Re := 0;
Noise_Counter.Re := 0;
Ton_A := 0;
Ton_B := 0;
Ton_C := 0;
Left_Chan := 0; Right_Chan := 0;
Tick_Counter := 0;
Tik.Re := Delay_In_Tiks;
Noise.Seed := $FFFF
end;

procedure Calculate_Level_Tables;
var
 i,b,l,r:integer;
 Index_A,Index_B,Index_C:integer;
 k:real;
begin
Index_A := Index_AL; Index_B := Index_BL; Index_C := Index_CL;
l := Index_A + Index_B + Index_C;
r := Index_AR + Index_BR + Index_CR;
if NumberOfChannels = 2 then
 begin
  if l < r then
   l := r;
 end
else
 begin
  l := l + r;
  Inc(Index_A,Index_AR);
  Inc(Index_B,Index_BR);
  Inc(Index_C,Index_CR)
 end;
if l = 0 then Inc(l);
if SampleBit = 8 then
 r := 127
else
 r := 32767;
l := 255*r div l;
case ChType of
{AY_Chip:
 for i := 0 to 15 do
  begin
   b := round(Index_A/255*Amplitudes_AY[i]);
   b := round(b/65535*l);
   Level_AL[i*2] := b; Level_AL[i*2 + 1] := b;
   b := round(Index_AR/255*Amplitudes_AY[i]);
   b := round(b/65535*l);
   Level_AR[i*2] := b; Level_AR[i*2 + 1] := b;
   b := round(Index_B/255*Amplitudes_AY[i]);
   b := round(b/65535*l);
   Level_BL[i*2] := b; Level_BL[i*2 + 1] := b;
   b := round(Index_BR/255*Amplitudes_AY[i]);
   b := round(b/65535*l);
   Level_BR[i*2] := b; Level_BR[i*2 + 1] := b;
   b := round(Index_C/255*Amplitudes_AY[i]);
   b := round(b/65535*l);
   Level_CL[i*2] := b; Level_CL[i*2 + 1] := b;
   b := round(Index_CR/255*Amplitudes_AY[i]);
   b := round(b/65535*l);
   Level_CR[i*2] := b; Level_CR[i*2 + 1] := b
  end;}
YM_Chip:
 for i := 0 to 31 do
  begin
   b := trunc(Index_A/255*Amplitudes_YM[i]);
   Level_AL[i] := trunc(b/65535*l);
   b := trunc(Index_AR/255*Amplitudes_YM[i]);
   Level_AR[i] := trunc(b/65535*l);
   b := trunc(Index_B/255*Amplitudes_YM[i]);
   Level_BL[i] := trunc(b/65535*l);
   b := trunc(Index_BR/255*Amplitudes_YM[i]);
   Level_BR[i] := trunc(b/65535*l);
   b := trunc(Index_C/255*Amplitudes_YM[i]);
   Level_CL[i] := trunc(b/65535*l);
   b := trunc(Index_CR/255*Amplitudes_YM[i]);
   Level_CR[i] := trunc(b/65535*l)
  end
end;
k := (exp(PreAmp*ln(2)/PreAmpMax) - 1);
for i := 0 to 31 do
 begin
  Level_AL[i] := trunc(Level_AL[i]*k);
  Level_AR[i] := trunc(Level_AR[i]*k);
  Level_BL[i] := trunc(Level_BL[i]*k);
  Level_BR[i] := trunc(Level_BR[i]*k);
  Level_CL[i] := trunc(Level_CL[i]*k);
  Level_CR[i] := trunc(Level_CR[i]*k)
 end;
if SampleBit = 8 then
 BeeperLevel := -trunc(BeeperMax div 2 * k)
else
 BeeperLevel := -trunc(BeeperMax * 128 * k)
end;
{
procedure SynthesizerAY;
asm
  cmp IntFlag,0
  jnz @me
  mov eax,CurrentTact
  sub eax,Previous_Tact
  mov ecx,eax
  cmp Optimization_For_Quality,0
  jnz @me1
  mul dword ptr [SampleRateByFrqZ80]
  xchg eax,ecx
  push edx
  mul dword ptr [SampleRateByFrqZ80 + 4]
  jmp @me3
@me1:
  mul dword ptr [FrqAyByFrqZ80]
  xchg eax,ecx
  push edx
  mul dword ptr [FrqAyByFrqZ80 + 4]
@me3:
  pop edx
  add eax,edx
  add ecx,Number_Of_Tiks.lo
  adc eax,Number_Of_Tiks.hi
  jz @me2
  mov Number_Of_Tiks.hi,eax
  mov Number_Of_Tiks.lo,ecx
  mov eax,CurrentTact
  mov Previous_Tact,eax
  mov eax,edx
@me:
  mov IntFlag,0
  mov eax,BufP
  call [Synthesizer_Beeper]
@me2:
end;
}
procedure SynthesizerZX50;
begin
if not IntFlag then
 begin
 if Optimization_For_Quality then
  Number_Of_Tiks.hi := AY_Tiks_In_Interrupt
 else
  Number_Of_Tiks.hi := Sample_Tiks_In_Interrupt
 end
else
 IntFlag := False;
Synthesizer(Buf)
end;
{
procedure SynthesizerOUT;
var
 ZX_Takt2:smallint;
 Number_Of_Takts:smallInt;
 N_Of_Tiks:packed record
     case boolean of
      false:(lo:longword;
             hi:longword);
      true: (re:int64);
     end;
begin
if not IntFlag then
 begin
 if ZX_Takt=-1 then ZX_Takt2:=0 else ZX_Takt2:=ZX_Takt;
 Number_Of_Takts:=ZX_Takt2-Previous_Takt;
 if (Number_Of_Takts<=0) then inc(Number_Of_Takts,17472)
 else if (flg>0) then inc(Number_Of_Takts,17472);
 if Optimization_For_Quality then
  N_Of_Tiks.Re:=Number_Of_Tiks.Re+
                 Number_Of_Takts*FrqAyByFrqZ80
 else N_Of_Tiks.Re:=Number_Of_Tiks.Re+
                 Number_Of_Takts*SamplerateByFrqZ80;
 if N_Of_Tiks.Hi=0 then
  begin
  if ZX_Takt2=0 then inc(Flg);
  exit;
  end;
 Flg:=0;
 Number_Of_Tiks.Re := N_Of_Tiks.Re;
 Previous_Takt:=ZX_Takt2;
 end
else
 IntFlag:=False;
Synthesizer(Buf)
end;
}
procedure SynthesizerYM6;
begin
if not IntFlag then
 begin
  inc(Number_Of_Tiks.re,YM6Tiks);
  if Number_Of_Tiks.hi = 0 then exit
 end
else
 IntFlag := False;
Synthesizer(Buf)
end;
{
procedure SynthesizerEPSG;
var
 N_Of_Tiks:packed record
     case boolean of
      false:(lo:longword;
             hi:longword);
      true: (re:int64);
     end;
begin
if not IntFlag then
 begin
  Number_Of_AY_Takts := AY_Takt - Previous_AY_Takt;
  if Optimization_For_Quality then
   N_Of_Tiks.Re := Number_Of_Tiks.Re + Number_Of_AY_Takts * FrqAyByFrqZ80
  else
   N_Of_Tiks.Re := Number_Of_Tiks.Re + Number_Of_AY_Takts * SampleRateByFrqZ80;
  if N_Of_Tiks.hi = 0 then exit;
  Number_Of_Tiks.Re := N_Of_Tiks.Re;
  Previous_AY_Takt := AY_Takt
 end
else
 IntFlag := False;
Synthesizer(Buf)
end;

procedure SynthesizerZXAY;
var
 N_Of_Tiks:packed record
     case boolean of
      false:(lo:longword;
             hi:longword);
      true: (re:int64);
     end;
begin
if not IntFlag then
 begin
  Number_Of_AY_Takts := AY_Takt - Previous_AY_Takt;
  if (Number_Of_AY_Takts <= 0) then inc(Number_Of_AY_Takts,$100000)
  else if (flg > 0) then inc(Number_Of_AY_Takts,$100000);
  if Optimization_For_Quality then
   N_Of_Tiks.Re := Number_Of_Tiks.Re + Number_Of_AY_Takts*FrqAyByFrqZ80
  else
   N_Of_Tiks.Re := Number_Of_Tiks.Re + Number_Of_AY_Takts*SampleRateByFrqZ80;
  if N_Of_Tiks.hi = 0 then
   begin
    if AY_Takt = 0 then inc(Flg);
    exit
   end;
  Flg := 0;
  Number_Of_Tiks.Re := N_Of_Tiks.Re;
  Previous_AY_Takt := AY_Takt
 end
else
 IntFlag := False;
Synthesizer(Buf);
end;
}
procedure SetOptimization;
begin
if Optimization_For_Quality = Q then exit;
Optimization_For_Quality := Q;
if Q then
 begin
 AtariTimerPeriod1 := AtariTimerPeriod1/SampleRate*(AY_Freq div 8);
 AtariTimerPeriod2 := AtariTimerPeriod2/SampleRate*(AY_Freq div 8);
 AtariTimerCounter1 := AtariTimerCounter1/SampleRate*(AY_Freq div 8);
 AtariTimerCounter2 := AtariTimerCounter2/SampleRate*(AY_Freq div 8);
 YM6CurTik := YM6CurTik/SampleRate*(AY_Freq div 8);
 Current_Tik:= trunc(Current_Tik/SampleRate*(AY_Freq div 8));
 Number_Of_Tiks.Re:= trunc(Number_Of_Tiks.Re/SampleRate*(AY_Freq div 8));
 if NumberOfChannels = 2 then
  begin
   if SampleBit = 8 then
    begin
     Synthesizer := Synthesizer_Stereo8;
     Synthesizer_Beeper := Synthesizer_Stereo8_Beeper
    end
   else
    begin
     Synthesizer := Synthesizer_Stereo16;
     Synthesizer_Beeper := Synthesizer_Stereo16_Beeper
    end
  end
 else if SampleBit = 8 then
  begin
   Synthesizer := Synthesizer_Mono8;
   Synthesizer_Beeper := Synthesizer_Mono8_Beeper
  end
 else
  begin
   Synthesizer := Synthesizer_Mono16;
   Synthesizer_Beeper := Synthesizer_Mono16_Beeper
  end
 end
else
 begin
 AtariTimerPeriod1 := AtariTimerPeriod1/(AY_Freq div 8)*SampleRate;
 AtariTimerPeriod2 := AtariTimerPeriod2/(AY_Freq div 8)*SampleRate;
 AtariTimerCounter1 := AtariTimerCounter1/(AY_Freq div 8)*SampleRate;
 AtariTimerCounter2 := AtariTimerCounter2/(AY_Freq div 8)*SampleRate;
 YM6CurTik := YM6CurTik/(AY_Freq div 8)*SampleRate;
 Current_Tik:= trunc(Current_Tik/(AY_Freq div 8)*SampleRate);
 Number_Of_Tiks.Re:= trunc(Number_Of_Tiks.Re/(AY_Freq div 8)*SampleRate);
 if NumberOfChannels = 2 then
  begin
   if SampleBit = 8 then
    begin
     Synthesizer := Synthesizer_Stereo8_P;
     Synthesizer_Beeper := Synthesizer_Stereo8_P_Beeper
    end
   else
    begin
     Synthesizer := Synthesizer_Stereo16_P;
     Synthesizer_Beeper := Synthesizer_Stereo16_P_Beeper
    end
  end
 else if SampleBit=8 then
  begin
   Synthesizer := Synthesizer_Mono8_P;
   Synthesizer_Beeper := Synthesizer_Mono8_P_Beeper
  end
 else
  begin
   Synthesizer := Synthesizer_Mono16_P;
   Synthesizer_Beeper := Synthesizer_Mono16_P_Beeper
  end
 end;
end;

end.
