{
This uses parts of AY Emulator project
AY-3-8910/12 Emulator
Version 2.7 for Windows 95
Author Sergey Vladimirovich Bulba
(c)1999-2003 S.V.Bulba
}

{
Very preliminary SDL audio routine by
Martin Andersson (2003-03-30)
}

program SimplePlayer;

uses
    SDL in '../JEDI-SDL/SDL.pp',
    Players,
    WaveOutAPI,
    SquareToneLib,
    SysUtils,
    Playlist;

type
 PUint8 = ^UInt8;
 PUint32 = ^UInt32;
 
 var
  Buffer1, Buffer2 : PBuf;
  PBuffer:PBuf;
  pos:integer;


procedure fill_audio(udata: Pointer; stream: PUint8; len: Integer); cdecl;
    var
        partial:integer;
    begin
        if Real_End then exit;

        //This code is needed due to different sizes
        //between the YM-buffer(32680) and SDL's mixing
        //buffer(4096, 32768 etc... 2^x).
        if (pos + len > BuffLen * BlockAlign) then
        begin   //SDL wants to mix len nr of samples,
                //but our YM-buffer dont hold that much data,
                //(and not filling the complete SDL stream
                //will produce clicks),
                //so mix whats in the buffer then generate
                //another buffer and mix the missing part
                //from there.

                //mix whats available
                partial := BuffLen * BlockAlign - pos;
                SDL_MixAudio(stream, @PBuffer^[pos],
                        partial,
                        SDL_MIX_MAXVOLUME );

                //swap buffers
                if(PBuffer = Buffer1) then
                        PBuffer := Buffer2
                else PBuffer := Buffer1;

                MakeBuffer(@PBuffer^[0]);

                //mix the rest
                inc(stream, partial);
                SDL_MixAudio(stream, @PBuffer^[0],
                        len-partial,
                        SDL_MIX_MAXVOLUME);

                //set correct pos for next mix...
                pos := len-partial;
        end else
        begin
                SDL_MixAudio(stream, @PBuffer^[pos],
                        len,
                        SDL_MIX_MAXVOLUME );

                pos := pos + len;
        end;
    end;


function WOThreadActive:boolean;
begin
   Result := SDL_GetAudioStatus = SDL_AUDIO_PLAYING;
end;
    
procedure StopPlaying;
begin
if WOThreadActive then
 begin
  IsPlaying := False;
  SDL_CloseAudio;
  Dispose(Buffer1);
  Dispose(Buffer2);
 end;
end;

procedure WOPauseRestart;
begin
     if WOThreadActive then
     begin
        SDL_PauseAudio(1);
        Paused := True;
     end
     else
     begin
         SDL_PauseAudio(0);
         Paused := False;
     end;
end;

// rounds to nearest power of two
function roundPow2(n:double):integer;
begin
     if n > 0 then
        roundPow2:=round ( exp( trunc( ln(n)/ln(2) ) * ln(2) ))
     else //FIXME throw Error?
         roundPow2:=0;
end;

procedure StartWOThread;
var
   wanted : TSDL_AudioSpec;
begin
     if WOThreadActive then exit;

      // Set the audio format
      wanted.freq := SampleRate;
      case SampleBit of
           8:  wanted.format := AUDIO_S8;
           16: wanted.format := AUDIO_S16;
      end;
      wanted.channels := NumberOfChannels;

      //samples doesnt have to be same as BufferLength,
      //though it must be a power of two
      wanted.samples := roundPow2(BufferLength);
      wanted.callback := fill_audio;
      wanted.userdata := nil;
      pos := 0;

      New(Buffer1);
      New(Buffer2);

      PBuffer := Buffer1;
      MakeBuffer(@PBuffer^[0]);

      // Open the audio device, forcing the desired formats
      if ( SDL_OpenAudio( @wanted, nil) < 0 ) then
      begin
        WriteLn(PChar(Format('Couldn''t open SDL Audio : %s', [SDL_GetError])));
        isPlaying := False;
        exit;
      end;

      SDL_PauseAudio(0);

      IsPlaying := True;
      Reseted := False;
end;

begin
   SetDefault;

   //add first arg to playlist
   Add_Songs_From_File(paramstr(1), true);

   //prepare first playlist item for playing
   PrepareItem(0);
   InitForAllTypes(true);

   //set up some globals based on song
   Time_ms := round(PlayListItems[0]^.Time / Interrupt_Freq * 1000000);
   Global_Tick_Max := PlayListItems[0]^.Time;
   if PlayListItems[0]^.Loop < 0 then
        PlayListItems[0]^.Loop := 0;
   LoopVBL := PlayListItems[0]^.Loop;

   //initialize SDL audio output
   StartWOThread;

   WriteLn('*** AY Emulator v2.7 beta 3 ***');
   WriteLn('Playing... Control-C to abort!');

   try
        while(not Real_End) do
                SDL_Delay(100);
   except on EControlC do
              WriteLn('Aborting...');
   end;

   StopPlaying;
   FreePlayingResourses;
   DelPlayListItem;
   SDL_Quit;
   
end.
