{
This uses parts of AY Emulator project
AY-3-8910/12 Emulator
Version 2.7 for Windows 95
Author Sergey Vladimirovich Bulba
(c)1999-2003 S.V.Bulba
}

Unit SquareToneLib;

interface
function roundPow2(n:double):integer;
procedure SetBuffers(len,num:integer);
procedure SetDefault;

implementation
uses
    Globals,
    SysUtils,
    WaveOutAPI,
    Playlist,
    Players,
    AY;
    
// rounds to nearest power of two
function roundPow2(n:double):integer;
begin
     if n > 0 then
        roundPow2:= trunc( exp( trunc( ln(n)/ln(2) ) * ln(2) ))
     else //FIXME throw Error?
         roundPow2:=0;
end;    

procedure SetBuffers(len,num:integer);
begin
//FIXME: if WOThreadActive then exit;
if (num < 2) or (num > 10) then exit;
if (len < 5) or (len > 2000) then exit;
BufLen_ms := len;
NumberOfBuffers := num;
//YM-buffer rounded to a power of two for efficiency (not requirement)
BufferLength := roundPow2(BufLen_ms * SampleRate / 1000);
BlockAlign := (SampleBit div 8) * NumberOfChannels;
//VisPosMax := round(BufferLength * NumberOfBuffers / VisStep) + 1;
//VisTickMax := VisStep * VisPosMax;
//SetLength(VisPoints,VisPosMax);
end;

    
procedure Set_Player_Frq(Fr:longword);
begin
if (Fr >= 1000) and (Fr <= 2000000) and (Interrupt_Freq <> Fr) then
 begin
  if (Interrupt_Freq <> Fr) and FileAvailable and
                       (CurFileType in [MinVBLType..MaxVBLType])then
   begin
    Time_ms := round(Time_ms/Fr*Interrupt_Freq);
    ProgrMax := round(Time_ms/1000*SampleRate);
    VProgrPos := round(VProgrPos/Fr*Interrupt_Freq)
   end;
  Interrupt_Freq := Fr;
  if IsPlaying then
  YM6SamTiksOnInt := SampleRate/Interrupt_Freq*1000;
  Sample_Tiks_in_Interrupt := trunc(SampleRate/Interrupt_Freq*1000);
  AY_Tiks_In_Interrupt := trunc(AY_Freq/(Interrupt_Freq/1000*8));
  YM6TiksOnInt := AY_Freq/(Interrupt_Freq/1000*8);
 end
end;

procedure Set_Sample_Rate(SR:integer);
begin
if not ((SR >= 8000) and (SR < 300000)) then exit;
SampleRate := SR;
//VisStep := round(SampleRate/100);
   BufferLength := trunc(BufLen_ms * SampleRate / 1000);
//VisPosMax := round(BufferLength * NumberOfBuffers / VisStep) + 1;
//VisTickMax := VisStep * VisPosMax;
//SetLength(VisPoints,VisPosMax);
   Delay_In_Tiks := trunc(8192/SampleRate*AY_Freq);
   YM6SamTiksOnInt := SampleRate/Interrupt_Freq*1000;
   Sample_Tiks_in_Interrupt := trunc(SampleRate/Interrupt_Freq*1000);
end;

Procedure Set_Chip_Frq(Fr:integer);
begin
if (Fr >= 1000000) and (Fr <= 3000000) then
 begin
  AY_Freq := Fr;
  if MFPTimerMode = 0 then
   MFPTimerFrq := trunc(AY_Freq * 16 / 13);
  Delay_In_Tiks := trunc(8192/SampleRate * AY_Freq);
  Tik.Re := Delay_In_Tiks;
  AY_Tiks_In_Interrupt := trunc(AY_Freq/(Interrupt_Freq/1000 * 8));
  YM6TiksOnInt := AY_Freq/(Interrupt_Freq/1000 * 8);
  if IsPlaying then
   begin
   end
 end
end;

procedure Set_MFP_Frq(Md,Fr:integer);
begin
if Md = 0 then
 begin
  MFPTimerMode := 0;
  MFPTimerFrq := trunc(AY_Freq * 16 / 13)
 end
else
 if (Fr >= 1000000) and (Fr <= 3000000) then
  begin
   MFPTimerMode := 1;
   MFPTimerFrq := Fr
  end;
end;

procedure SetSynthesizer;
begin
if Optimization_For_Quality then
 begin
  if NumberOfChannels = 2 then
   begin
    if SampleBit = 8 then
     begin
      Synthesizer := Synthesizer_Stereo8;
      Synthesizer_Beeper := Synthesizer_Stereo8_Beeper;
     end
    else
     begin
      Synthesizer := Synthesizer_Stereo16;
      Synthesizer_Beeper := Synthesizer_Stereo16_Beeper;
     end
   end
  else if SampleBit = 8 then
   begin
    Synthesizer := Synthesizer_Mono8;
    Synthesizer_Beeper := Synthesizer_Mono8_Beeper;
   end
  else
   begin
    Synthesizer := Synthesizer_Mono16;
    Synthesizer_Beeper := Synthesizer_Mono16_Beeper;
   end
 end
else
 begin
  if NumberOfChannels = 2 then
   begin
    if SampleBit = 8 then
     begin
      Synthesizer := Synthesizer_Stereo8_P;
      Synthesizer_Beeper := Synthesizer_Stereo8_P_Beeper;
     end
    else
     begin
      Synthesizer := Synthesizer_Stereo16_P;
      Synthesizer_Beeper := Synthesizer_Stereo16_P_Beeper;
     end
   end
  else if SampleBit = 8 then
   begin
    Synthesizer := Synthesizer_Mono8_P;
    Synthesizer_Beeper := Synthesizer_Mono8_P_Beeper;
   end
  else
   begin
    Synthesizer := Synthesizer_Mono16_P;
    Synthesizer_Beeper := Synthesizer_Mono16_P_Beeper;
   end
 end;
   Calculate_Level_Tables
end;

procedure Set_Sample_Bit(SB:integer);
begin
SampleBit := SB;
SetSynthesizer
end;

procedure Set_Stereo(St:integer);
begin
NumberOfChannels := St;
SetSynthesizer
end;

procedure Set_Mode_Manual(AL,AR,BL,BR,CL,CR:byte);
begin
Index_AL := AL; Index_AR := AR;
Index_BL := BL; Index_BR := BR;
Index_CL := CL; Index_CR := CR;
Calculate_Level_Tables
end;

procedure SetDefault;
begin
PreAmp := 1;
PreAmpMax := 1;
BeeperMax := BeeperMaxDef;
Set_Player_Frq(Interrupt_FreqDef);
Set_Sample_Rate(SampleRateDef); //FIXME: Should only be set when not playing!
Set_Chip_Frq(FrqSTDef);
Set_MFP_Frq(MFPTimerModeDef,MFPTimerFrqDef);
IntOffset := IntOffsetDef;
Set_Sample_Bit(SampleBitDef);
Set_Stereo(NumOfChanDef);
SetBuffers(BufLen_msDef,NumberOfBuffersDef);
Set_Mode_Manual(Index_ALDef,Index_ARDef,Index_BLDef,Index_BRDef,
                Index_CLDef,Index_CRDef);
ChType := YM_Chip;
Calculate_Level_Tables;
   Do_Loop := FALSE;
end;

end.